#define UART_C

#include "UART.h"

void InitUART1(int Baud, int RXpin, int TXpin )
{
	int BRGVAL1 = ((FCY/Baud)/16)-1;
	
	RPINR18bits.U1RXR = RXpin;    // Make Pin RXpin U1RX

	switch (TXpin)
	{
		case 0 : 
			RPOR0bits.RP0R = 3;
			break;	
		case 1 : 
			RPOR0bits.RP1R = 3;
			break;
		case 2 : 
			RPOR1bits.RP2R = 3;
			break;
		case 3 : 
			RPOR1bits.RP3R = 3;
			break;
		case 4 : 
			RPOR2bits.RP4R = 3;
			break;
		case 5 : 
			RPOR2bits.RP5R = 3;
			break;
		case 6 : 
			RPOR3bits.RP6R = 3;
			break;
		case 7 : 
			RPOR3bits.RP7R = 3;
			break;
		case 8 : 
			RPOR4bits.RP8R = 3;
			break;
		case 9 : 
			RPOR4bits.RP9R = 3;
			break;
		case 10 : 
			RPOR5bits.RP10R = 3;
			break;
		case 11 : 
			RPOR5bits.RP11R = 3;
			break;
		case 12 : 
			RPOR6bits.RP12R = 3;
			break;
		case 13 : 
			RPOR6bits.RP13R = 3;
			break;
		case 14 : 
			RPOR7bits.RP14R = 3;
			break;
		case 15 : 
			RPOR7bits.RP15R = 3;
			break;
	}

	//adicionar a instrucao pra bloquear o relogio e os pinos

	// configure U2MODE
   	U1MODEbits.UARTEN = 0;	// Bit15 TX, RX DISABLED, ENABLE at end of func
	U1MODEbits.USIDL = 0;	// Bit13 Continue in Idle
	U1MODEbits.IREN = 0;	// Bit12 No IR translation
	U1MODEbits.RTSMD = 0;	// Bit11 Simplex Mode
	U1MODEbits.UEN = 0;		// Bits8,9 TX,RX enabled, CTS,RTS not
	U1MODEbits.WAKE = 0;	// Bit7 No Wake up (since we don't sleep here)
	U1MODEbits.LPBACK = 0;	// Bit6 No Loop Back
	U1MODEbits.ABAUD = 0;	// Bit5 No Autobaud (would require sending '55')
	U1MODEbits.RXINV = 0;	// Bit4 IdleState = 1
	U1MODEbits.BRGH = 0;	// Bit3 16 clocks per bit period
	U1MODEbits.PDSEL = 0;	// Bits1,2 8bit, No Parity
	U1MODEbits.STSEL = 0;	// Bit0 One Stop Bit

	//U1BRG = 12 //9600baud @ 4MHz
	//U1BRG = 25 ;//9600baud @ 8MHz
  	U1BRG = BRGVAL1;	 		//Baud Rate Generator Prescaler

	// Load all values in for U2STA SFR
	U1STAbits.UTXISEL1 = 0;	//Bit15 Int when Char is transferred (1/2 config!)
	U1STAbits.UTXINV = 0;	//Bit14 N/A, IRDA config
	U1STAbits.UTXISEL0 = 0;	//Bit13 Other half of Bit15
	U1STAbits.UTXBRK = 0;	//Bit11 Disabled
	U1STAbits.UTXEN = 0;	//Bit10 TX pins controlled by periph
	U1STAbits.UTXBF = 0;	//Bit9 *Read Only Bit*
	U1STAbits.TRMT = 0;		//Bit8 *Read Only bit*
	U1STAbits.URXISEL = 0;	//Bits6,7 interrupt when any character is recieved
	U1STAbits.ADDEN = 0;	//Bit5 Address Detect Disabled
	U1STAbits.RIDLE = 0;	//Bit4 *Read Only Bit*
	U1STAbits.PERR = 0;		//Bit3 *Read Only Bit*
	U1STAbits.FERR = 0;		//Bit2 *Read Only Bit*
	U1STAbits.OERR = 0;		//Bit1 *Read Only Bit*
	U1STAbits.URXDA = 0;	//Bit0 *Read Only Bit*

	//Configuration the Transmit Interrupts
//	IPC7bits.U2TXIP = 4;    // Set Transmit interrupt priority to 4	
//	IFS1bits.U2TXIF = 0;	// Clear the Transmit Interrupt Flag
//	IEC1bits.U2TXIE = 1;	// Enable Transmit Interrupts
	//Configuration the  Recieve Interrupts
	IPC2bits.U1RXIP = 4;    // Set Recieve interrupt priority to 4
	IFS0bits.U1RXIF = 0;	// Clear the Recieve Interrupt Flag
	IEC0bits.U1RXIE = 1;	// Enable Recieve Interrupts

	//Initialization
	U1MODEbits.UARTEN = 1;	// And turn the peripheral ON
	U1STAbits.UTXEN = 1; // Transmit enabled, U2TX pin controlled by UART2
}

void InitUART2(int Baud, int RXpin, int TXpin )
{
	int BRGVAL = ((FCY/Baud)/16)-1;
	
	RPINR19bits.U2RXR = RXpin;    // Make Pin RXpin U2RX

	switch (TXpin)
	{
		case 0 : 
			RPOR0bits.RP0R = 5;
			break;	
		case 1 : 
			RPOR0bits.RP1R = 5;
			break;
		case 2 : 
			RPOR1bits.RP2R = 5;
			break;
		case 3 : 
			RPOR1bits.RP3R = 5;
			break;
		case 4 : 
			RPOR2bits.RP4R = 5;
			break;
		case 5 : 
			RPOR2bits.RP5R = 5;
			break;
		case 6 : 
			RPOR3bits.RP6R = 5;
			break;
		case 7 : 
			RPOR3bits.RP7R = 5;
			break;
		case 8 : 
			RPOR4bits.RP8R = 5;
			break;
		case 9 : 
			RPOR4bits.RP9R = 5;
			break;
		case 10 : 
			RPOR5bits.RP10R = 5;
			break;
		case 11 : 
			RPOR5bits.RP11R = 5;
			break;
		case 12 : 
			RPOR6bits.RP12R = 5;
			break;
		case 13 : 
			RPOR6bits.RP13R = 5;
			break;
		case 14 : 
			RPOR7bits.RP14R = 5;
			break;
		case 15 : 
			RPOR7bits.RP15R = 5;
			break;
	}

	//adicionar a instrucao pra bloquear o relogio e os pinos

	// configure U2MODE
   	U2MODEbits.UARTEN = 0;	// Bit15 TX, RX DISABLED, ENABLE at end of func
	U2MODEbits.USIDL = 0;	// Bit13 Continue in Idle
	U2MODEbits.IREN = 0;	// Bit12 No IR translation
	U2MODEbits.RTSMD = 0;	// Bit11 Simplex Mode
	U2MODEbits.UEN = 0;		// Bits8,9 TX,RX enabled, CTS,RTS not
	U2MODEbits.WAKE = 0;	// Bit7 No Wake up (since we don't sleep here)
	U2MODEbits.LPBACK = 0;	// Bit6 No Loop Back
	U2MODEbits.ABAUD = 0;	// Bit5 No Autobaud (would require sending '55')
	U2MODEbits.RXINV = 0;	// Bit4 IdleState = 1
	U2MODEbits.BRGH = 0;	// Bit3 16 clocks per bit period
	U2MODEbits.PDSEL = 0;	// Bits1,2 8bit, No Parity
	U2MODEbits.STSEL = 0;	// Bit0 One Stop Bit

	//U2BRG = 12 ;//9600baud @ 4MHz
	//U2BRG = 25 ;//9600baud @ 8MHz OR 4800Bbaud @4MHz
  	U2BRG = BRGVAL;	 		//Baud Rate Generator Prescaler

	// Load all values in for U2STA SFR
	U2STAbits.UTXISEL1 = 0;	//Bit15 Int when Char is transferred (1/2 config!)
	U2STAbits.UTXINV = 0;	//Bit14 N/A, IRDA config
	U2STAbits.UTXISEL0 = 0;	//Bit13 Other half of Bit15
	U2STAbits.UTXBRK = 0;	//Bit11 Disabled
	U2STAbits.UTXEN = 0;	//Bit10 TX pins controlled by periph
	U2STAbits.UTXBF = 0;	//Bit9 *Read Only Bit*
	U2STAbits.TRMT = 0;		//Bit8 *Read Only bit*
	U2STAbits.URXISEL = 0;	//Bits6,7 interrupt when any character is recieved
	U2STAbits.ADDEN = 0;	//Bit5 Address Detect Disabled
	U2STAbits.RIDLE = 0;	//Bit4 *Read Only Bit*
	U2STAbits.PERR = 0;		//Bit3 *Read Only Bit*
	U2STAbits.FERR = 0;		//Bit2 *Read Only Bit*
	U2STAbits.OERR = 0;		//Bit1 *Read Only Bit*
	U2STAbits.URXDA = 0;	//Bit0 *Read Only Bit*

	//Configuration the Transmit Interrupts
//	IPC7bits.U2TXIP = 4;    // Set Transmit interrupt priority to 4	
//	IFS1bits.U2TXIF = 0;	// Clear the Transmit Interrupt Flag
//	IEC1bits.U2TXIE = 1;	// Enable Transmit Interrupts
	//Configuration the  Recieve Interrupts
	IPC7bits.U2RXIP = 4;    // Set Recieve interrupt priority to 4
	IFS1bits.U2RXIF = 0;	// Clear the Recieve Interrupt Flag
	IEC1bits.U2RXIE = 1;	// Enable Recieve Interrupts

	//Initialization
	U2MODEbits.UARTEN = 1;	// And turn the peripheral ON
	U2STAbits.UTXEN = 1; // Transmit enabled, U2TX pin controlled by UART2
}

void TX1 (char *strTX)
{
	int i=0;
	
	for(i = 0;i < strlen(strTX);i++)
	{
		U1TXREG = strTX[i];
		while(!U1STAbits.TRMT);
	}
	
	U2TXREG = 0x0D; //send Carriage Return
	while(!U2STAbits.TRMT);
	U2TXREG = 0x0A; //send Line Feed
}

void TX2 (char *strTX)
{
	int i=0;
	
	for(i = 0;i < strlen(strTX);i++)
	{
		U2TXREG = strTX[i];
		while(!U2STAbits.TRMT);

	}
	
	U2TXREG = 0x0D; //send Carriage Return
	while(!U2STAbits.TRMT);
	U2TXREG = 0x0A; //send Line Feed
}



